diff --git a/src/xen/xend_internal.c b/src/xen/xend_internal.c
index 6f98dc0..70f6ac4 100644
--- a/src/xen/xend_internal.c
+++ b/src/xen/xend_internal.c
@@ -3098,6 +1798,9 @@ xenDaemonDomainFetch(virConnectPtr conn,
     struct sexpr *root;
     xenUnifiedPrivatePtr priv;
     virDomainDefPtr def;
+    int id;
+    char * tty;
+    int vncport;
 
     if (name)
         root = sexpr_get(conn, "/xend/domain/%s?detail=1", name);
@@ -3112,10 +1815,16 @@ xenDaemonDomainFetch(virConnectPtr conn,
 
     priv = (xenUnifiedPrivatePtr) conn->privateData;
 
-    if (!(def = xenDaemonParseSxpr(conn,
-                                   root,
+    id = xenGetDomIdFromSxpr(root, priv->xendConfigVersion);
+    xenUnifiedLock(priv);
+    tty = xenStoreDomainGetConsolePath(conn, id);
+    vncport = xenStoreDomainGetVNCPort(conn, id);
+    xenUnifiedUnlock(priv);
+    if (!(def = xenDaemonParseSxpr(root,
                                    priv->xendConfigVersion,
-                                   cpus)))
+                                   cpus,
+                                   tty,
+                                   vncport)))
         goto cleanup;
 
 cleanup:
@@ -5043,6 +3752,9 @@ xenDaemonDomainBlockPeek (virDomainPtr domain, const char *path,
     int fd = -1, ret = -1;
     int found = 0, i;
     virDomainDefPtr def;
+    int id;
+    char * tty;
+    int vncport;
 
     priv = (xenUnifiedPrivatePtr) domain->conn->privateData;
 
@@ -5068,7 +3780,14 @@ xenDaemonDomainBlockPeek (virDomainPtr domain, const char *path,
         return -1;
     }
 
-    if (!(def = xenDaemonParseSxpr(domain->conn, root, priv->xendConfigVersion, NULL)))
+    id = xenGetDomIdFromSxpr(root, priv->xendConfigVersion);
+    xenUnifiedLock(priv);
+    tty = xenStoreDomainGetConsolePath(domain->conn, id);
+    vncport = xenStoreDomainGetVNCPort(domain->conn, id);
+    xenUnifiedUnlock(priv);
+
+    if (!(def = xenDaemonParseSxpr(root, priv->xendConfigVersion, NULL, tty,
+                                   vncport)))
         goto cleanup;
 
     for (i = 0 ; i < def->ndisks ; i++) {
diff --git a/src/xen/xend_internal.h b/src/xen/xend_internal.h
index 53f5d2c..8603a08 100644
--- a/src/xen/xend_internal.h
+++ b/src/xen/xend_internal.h
@@ -27,12 +27,6 @@
 # include "driver.h"
 # include "buf.h"
 
-# ifdef __sun
-#  define DEFAULT_VIF_SCRIPT "vif-vnic"
-# else
-#  define DEFAULT_VIF_SCRIPT "vif-bridge"
-# endif
-
 int
 xenDaemonOpen_unix(virConnectPtr conn, const char *path);
 
@@ -96,18 +90,6 @@ xenDaemonDomainFetch(virConnectPtr xend,
                      const char *name,
                      const char *cpus);
 
-virDomainDefPtr
-xenDaemonParseSxprString(virConnectPtr conn,
-                         const char *sexpr,
-                         int xendConfigVersion);
-
-int
-xenDaemonParseSxprSound(virDomainDefPtr def,
-                        const char *str);
-
-virDomainChrDefPtr
-xenDaemonParseSxprChar(const char *value,
-                       const char *tty);
 
 int
 xenDaemonFormatSxprChr(virDomainChrDefPtr def,
diff --git a/src/xen/xm_internal.c b/src/xen/xm_internal.c
index 865805c..2991336 100644
--- a/src/xen/xm_internal.c
+++ b/src/xen/xm_internal.c
@@ -40,6 +40,7 @@
 #include "xm_internal.h"
 #include "xen_driver.h"
 #include "xend_internal.h"
+#include "xen_sxpr.h"
 #include "hash.h"
 #include "buf.h"
 #include "uuid.h"
